<cfcomponent displayname="ProjectService" output="false">

	<cfset variables.instance = StructNew() />

	<cffunction name="init" access="public" returntype="components.services.ProjectService" output="false">
    	<cfargument name="config" required="yes" type="any">
		<cfset variables.url = config.getUrl() />
        <cfreturn this />
    </cffunction> 
	<!--- Startup stuff because of modelglue/coldspring. --->
   	<cffunction name="getProjectGateway" access="public" output="false" returntype="any">
      	<cfreturn variables.instance.projectGateway />
   	</cffunction>
	   
   	<cffunction name="setProjectGateway" access="public" output="false" returntype="void">
      	<cfargument name="projectGateway" type="components.project.projectGateway" required="true" />
      	<cfset variables.instance.projectGateway = arguments.projectGateway />
   	</cffunction>

   	<cffunction name="getProjectMemberGateway" access="public" output="false" returntype="any">
      	<cfreturn variables.instance.projectMemberGateway />
   	</cffunction>
	   
   	<cffunction name="setProjectMemberGateway" access="public" output="false" returntype="void">
      	<cfargument name="projectMemberGateway" type="components.project.projectMemberGateway" required="true" />
      	<cfset variables.instance.projectMemberGateway = arguments.projectMemberGateway />
   	</cffunction>

   	<cffunction name="getProjectNotesGateway" access="public" output="false" returntype="any">
      	<cfreturn variables.instance.projectNotesGateway />
   	</cffunction>
	   
   	<cffunction name="setProjectNotesGateway" access="public" output="false" returntype="void">
      	<cfargument name="projectNotesGateway" type="components.project.projectNotesGateway" required="true" />
      	<cfset variables.instance.projectNotesGateway = arguments.projectNotesGateway />
   	</cffunction>
	<!--- End of modelglue/coldspring related stuff. --->
	
	<cffunction name="getProject01" returntype="struct">
	</cffunction>

	<cffunction name="getProject02" returntype="struct">
		<cfset var project = structNew() />
		<cfreturn project />
	</cffunction>

	<cffunction name="getProject03" returntype="struct">
		<cfset var project = structNew() />
		<cfset project.project = getProjectGateway().getProjectList() />
		<cfreturn project />
	</cffunction>

	<cffunction name="getProject04" returntype="struct">
		<cfset var project = structNew() />
		<cfset project.project = getProjectGateway().getProjectList() />
		<cfset project.members = getProjectMemberGateway().getProjectMemberList() />
		<cfreturn project />
	</cffunction>

	<cffunction name="getProject05" returntype="struct">
		<cfset var project = structNew() />
		<cfset project.project = getProjectGateway().getProjectList() />
		<cfset project.members = getProjectMemberGateway().getProjectMemberList() />
		<cfset project.notes = getProjectNotesGateway().getProjectNotesList() />
		<cfreturn project />
	</cffunction>

	<cffunction name="getProject06" returntype="struct">
		<cfargument name="projectID" default="" />
		<cfset var project = structNew() />
		<cfset project.project = getProjectGateway().getProjectList(projectID = arguments.projectID) />
		<cfset project.members = getProjectMemberGateway().getProjectMemberList() />
		<cfset project.notes = getProjectNotesGateway().getProjectNotesList() />
		<cfreturn project />
	</cffunction>

	<cffunction name="getProject07" returntype="struct">
		<cfargument name="projectID" default="" />
		<cfset var project = structNew() />
		<cfset project.project = getProjectGateway().getProjectList(projectID = arguments.projectID) />
		<cfset project.members = getProjectMemberGateway().getProjectMemberList(projectID = arguments.projectID) />
		<cfset project.notes = getProjectNotesGateway().getProjectNotesList() />
		<cfreturn project />
	</cffunction>

	<cffunction name="getProject08" returntype="struct">
		<cfargument name="projectID" default="" />
		<cfset var project = structNew() />
		<cfset project.project = getProjectGateway().getProjectList(projectID = arguments.projectID) />
		<cfset project.members = getProjectMemberGateway().getProjectMemberList(projectID = arguments.projectID) />
		<cfset project.notes = getProjectNotesGateway().getProjectNotesList(projectID = arguments.projectID) />
		<cfreturn project />
	</cffunction>

</cfcomponent>
