<cfcomponent displayname="testProjects" extends="mxunit.framework.TestCase">
	<cfoutput>
		Note:<br />
		<strong>C_getProjectList_Returns_Records</strong> has been removed because it is obsolete.<br />
		By design, getProjectList returns 0 records when no arguments are passed.<br /><br />
	</cfoutput>
	<!--- Tests existence of function. --->
	<cffunction name="A_getProjectList_Exists" access="remote" returntype="void">
		<cfscript>
			ProjectGateway = createObject("component", "components.project.ProjectGateway");
			assertTrue(isQuery(ProjectGateway.getProjectList()));
		</cfscript>  
	</cffunction>
	<!--- Tests that a query is returned. --->
	<cffunction name="B_getProjectList_Returns_Query" access="remote" returntype="void">
		<cfscript>
			ProjectGateway = createObject("component", "components.project.ProjectGateway");
			assertTrue(isQuery(ProjectGateway.getProjectList()));
		</cfscript>  
	</cffunction>
	<!--- Tests that records are actually retrieved. --->
	<!--- Tests for meeting specific retrieval criteria. --->
	<cffunction name="D_getProjectList_createdBy" access="remote" returntype="void">
			<cfset ProjectGateway = createObject("component", "components.project.ProjectGateway") />
			<cfset getProjectList = ProjectGateway.getProjectList(createdBy = 1) />
			<cfloop query="getProjectList">
				<cfset assertTrue(getProjectList.createdBy eq 1, "Projects were returned with the wrong creator.") />
			</cfloop>
	</cffunction>
	<cffunction name="E_getProjectList_approvalStatus" access="remote" returntype="void">
			<cfset ProjectGateway = createObject("component", "components.project.ProjectGateway") />
			<cfset getProjectList = ProjectGateway.getProjectList(approvalStatus = 1) />
			<cfloop query="getProjectList">
				<cfset assertTrue(getProjectList.approvalStatus eq 1, "Unapproved projects were returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="F_getProjectList_projectID" access="remote" returntype="void">
			<cfset ProjectGateway = createObject("component", "components.project.ProjectGateway") />
			<cfset getProjectList = ProjectGateway.getProjectList(projectID = 1) />
			<cfloop query="getProjectList">
				<cfset assertTrue(getProjectList.projectID eq 1, "Projects were returned with the wrong ID.") />
			</cfloop>
	</cffunction>
	<cffunction name="G_getProjectList_Returns_Zero_Records" access="remote" returntype="void">
			<cfset ProjectGateway = createObject("component", "components.project.ProjectGateway") />
			<cfset getProjectList = ProjectGateway.getProjectList() />
			<cfset assertTrue(getProjectList.recordCount eq 0, "No arguments were sent. Query should have returned 0 results.") />
	</cffunction>
	<cffunction name="H_getProjectList_Returns_All_Records" access="remote" returntype="void">
			<cfset ProjectGateway = createObject("component", "components.project.ProjectGateway") />
			<cfset getProjectList = ProjectGateway.getProjectList(all = 1) />
			<cfset assertTrue(getProjectList.recordCount gt 0, "The 'all' argument was sent. Query should have returned results.") />
	</cffunction>
</cfcomponent>