<cfcomponent displayname="testProjects" extends="mxunit.framework.TestCase">
	<cfoutput>
	List of tests:<br />
	Does function exist?<br />
	Does function return a query?<br />
	Does function retrieve database records?<br />
	Does function accept arguments, and retrieve the correct records?<br />
	Does function return a blank query when no arguments are passed?<br />
	Does function return all records when the "all" argument is passed?<br /><br />
	</cfoutput>
	<!--- Tests existence of function. --->
	<cffunction name="A_getProjectList_Exists" access="remote" returntype="void">
		<cfscript>
			projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo");
			assertTrue(isQuery(projectGatewayDemo.getProjectList()));
		</cfscript>  
	</cffunction>
	<!--- Tests that a query is returned. --->
	<cffunction name="B_getProjectList_Returns_Query_Fails" access="remote" returntype="void">
		<cfscript>
			projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo");
			assertTrue(isQuery(projectGatewayDemo.getProjectList01()));
		</cfscript>  
	</cffunction>
	<cffunction name="B_getProjectList_Returns_Query_Passes" access="remote" returntype="void">
		<cfscript>
			projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo");
			assertTrue(isQuery(projectGatewayDemo.getProjectList02()));
		</cfscript>  
	</cffunction>
	<!--- Tests that records are actually retrieved. --->
	<cffunction name="C_getProjectList_Returns_Records_Fails" access="remote" returntype="void">
		<cfscript>
			projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo");
			assertTrue((projectGatewayDemo.getProjectList02().recordCount gt 0), "No records were returned.");
		</cfscript>  
	</cffunction>
	<cffunction name="C_getProjectList_Returns_Records_Passes" access="remote" returntype="void">
		<cfscript>
			projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo");
			assertTrue((projectGatewayDemo.getProjectList03().recordCount gt 0), "No records were returned.");
		</cfscript>  
	</cffunction>
	<!--- Tests for meeting specific retrieval criteria. --->
	<!--- Creator --->
	<cffunction name="D_getProjectList_Passes_createdBy_Fails" access="remote" returntype="void">
			<cfset projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo") />
			<cfset getProjectList = projectGatewayDemo.getProjectList03(createdBy = 1) />
			<cfloop query="getProjectList">
				<cfset assertTrue(getProjectList.createdBy eq 1, "Projects were returned with the wrong creator.") />
			</cfloop>
	</cffunction>
	<cffunction name="D_getProjectList_Passes_createdBy_Passes" access="remote" returntype="void">
			<cfset projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo") />
			<cfset getProjectList = projectGatewayDemo.getProjectList04(createdBy = 1) />
			<cfloop query="getProjectList">
				<cfset assertTrue(getProjectList.createdBy eq 1, "Projects were returned with the wrong creator.") />
			</cfloop>
	</cffunction>
	<!--- Approval --->
	<cffunction name="E_getProjectList_Passes_approvalStatus_Fails" access="remote" returntype="void">
			<cfset projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo") />
			<cfset getProjectList = projectGatewayDemo.getProjectList03(approvalStatus = 1) />
			<cfloop query="getProjectList">
				<cfset assertTrue(getProjectList.approvalStatus eq 1, "Unapproved projects were returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="E_getProjectList_Passes_approvalStatus_Passes" access="remote" returntype="void">
			<cfset projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo") />
			<cfset getProjectList = projectGatewayDemo.getProjectList04(approvalStatus = 1) />
			<cfloop query="getProjectList">
				<cfset assertTrue(getProjectList.approvalStatus eq 1, "Unapproved projects were returned.") />
			</cfloop>
	</cffunction>
	<!--- Project ID --->
	<cffunction name="F_getProjectList_Passes_projectID_Fails" access="remote" returntype="void">
			<cfset projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo") />
			<cfset getProjectList = projectGatewayDemo.getProjectList03(projectID = 1) />
			<cfloop query="getProjectList">
				<cfset assertTrue(getProjectList.projectID eq 1, "Projects were returned with the wrong ID.") />
			</cfloop>
	</cffunction>
	<cffunction name="F_getProjectList_Passes_projectID_Passes" access="remote" returntype="void">
			<cfset projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo") />
			<cfset getProjectList = projectGatewayDemo.getProjectList04(projectID = 1) />
			<cfloop query="getProjectList">
				<cfset assertTrue(getProjectList.projectID eq 1, "Projects were returned with the wrong ID.") />
			</cfloop>
	</cffunction>
	<cffunction name="G_getProjectList_Returns_Zero_Records_Fails" access="remote" returntype="void">
			<cfset projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo") />
			<cfset getProjectList = projectGatewayDemo.getProjectList04() />
			<cfset assertTrue(getProjectList.recordCount eq 0, "No arguments were sent. Query should have returned 0 results.") />
	</cffunction>
	<cffunction name="G_getProjectList_Returns_Zero_Records_Passes" access="remote" returntype="void">
			<cfset projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo") />
			<cfset getProjectList = projectGatewayDemo.getProjectList05() />
			<cfset assertTrue(getProjectList.recordCount eq 0, "No arguments were sent. Query should have returned 0 results.") />
	</cffunction>
	<cffunction name="H_getProjectList_Returns_All_Records_Fails" access="remote" returntype="void">
			<cfset projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo") />
			<cfset getProjectList = projectGatewayDemo.getProjectList05(all = 1) />
			<cfset assertTrue(getProjectList.recordCount gt 0, "The 'all' argument was sent. Query should have returned results.") />
	</cffunction>
	<cffunction name="H_getProjectList_Returns_All_Records_Passes" access="remote" returntype="void">
			<cfset projectGatewayDemo = createObject("component", "components.project.projectGatewayDemo") />
			<cfset getProjectList = projectGatewayDemo.getProjectList06(all = 1) />
			<cfset assertTrue(getProjectList.recordCount gt 0, "The 'all' argument was sent. Query should have returned results.") />
	</cffunction>
</cfcomponent>
