<cfcomponent displayname="testProjectMembers" extends="mxunit.framework.TestCase">
	<!--- Tests existence of function. --->
	<cffunction name="A_getProjectMemberList_Exists" access="remote" returntype="void">
		<cfscript>
			ProjectMemberGateway = createObject("component", "components.project.ProjectMemberGateway");
			assertTrue(isQuery(ProjectMemberGateway.getProjectMemberList()));
		</cfscript>  
	</cffunction>
	<!--- Tests that a query is returned. --->
	<cffunction name="B_getProjectMemberList_Returns_Query" access="remote" returntype="void">
		<cfscript>
			ProjectMemberGateway = createObject("component", "components.project.ProjectMemberGateway");
			assertTrue(isQuery(ProjectMemberGateway.getProjectMemberList()));
		</cfscript>  
	</cffunction>
	<!--- Tests for meeting specific retrieval criteria. --->
	<cffunction name="D_getProjectMemberList_userID" access="remote" returntype="void">
			<cfset ProjectMemberGateway = createObject("component", "components.project.ProjectMemberGateway") />
			<cfset getProjectMemberList = ProjectMemberGateway.getProjectMemberList(userID = 1) />
			<cfloop query="getProjectMemberList">
				<cfset assertTrue(getProjectMemberList.userID eq 1, "The wrong user was returned as a project member.") />
			</cfloop>
	</cffunction>
	<cffunction name="E_getProjectMemberList_projectSupervisor" access="remote" returntype="void">
			<cfset ProjectMemberGateway = createObject("component", "components.project.ProjectMemberGateway") />
			<cfset getProjectMemberList = ProjectMemberGateway.getProjectMemberList(projectSupervisor = 1) />
			<cfloop query="getProjectMemberList">
				<cfset assertTrue(getProjectMemberList.projectSupervisor eq 1, "A user who is not a project supervisor was returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="F_getProjectMemberList_projectID" access="remote" returntype="void">
			<cfset ProjectMemberGateway = createObject("component", "components.project.ProjectMemberGateway") />
			<cfset getProjectMemberList = ProjectMemberGateway.getProjectMemberList(projectID = 1) />
			<cfloop query="getProjectMemberList">
				<cfset assertTrue(getProjectMemberList.projectID eq 1, "Records tied to the wrong project were returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="G_getProjectMemberList_Returns_Zero_Records" access="remote" returntype="void">
			<cfset ProjectMemberGateway = createObject("component", "components.project.ProjectMemberGateway") />
			<cfset getProjectMemberList = ProjectMemberGateway.getProjectMemberList() />
			<cfset assertTrue(getProjectMemberList.recordCount eq 0, "No arguments were sent. Query should have returned 0 results.") />
	</cffunction>
	<cffunction name="H_getProjectMemberList_Returns_All_Records" access="remote" returntype="void">
			<cfset ProjectMemberGateway = createObject("component", "components.project.ProjectMemberGateway") />
			<cfset getProjectMemberList = ProjectMemberGateway.getProjectMemberList(all = 1) />
			<cfset assertTrue(getProjectMemberList.recordCount gt 0, "The 'all' argument was sent. Query should have returned results.") />
	</cffunction>
</cfcomponent>