<cfcomponent displayname="testProjects" extends="mxunit.framework.TestCase">
	<!--- Tests existence of function. --->
	<cffunction name="A_getProjectNotesList_Exists" access="remote" returntype="void">
		<cfscript>
			ProjectNotesGateway = createObject("component", "components.project.ProjectNotesGateway");
			assertTrue(isQuery(ProjectNotesGateway.getProjectNotesList()));
		</cfscript>  
	</cffunction>
	<!--- Tests that a query is returned. --->
	<cffunction name="B_getProjectNotesList_Returns_Query" access="remote" returntype="void">
		<cfscript>
			ProjectNotesGateway = createObject("component", "components.project.ProjectNotesGateway");
			assertTrue(isQuery(ProjectNotesGateway.getProjectNotesList()));
		</cfscript>  
	</cffunction>
	<!--- Tests for meeting specific retrieval criteria. --->
	<cffunction name="D_getProjectNotesList_noteID" access="remote" returntype="void">
			<cfset ProjectNotesGateway = createObject("component", "components.project.ProjectNotesGateway") />
			<cfset getProjectNotesList = ProjectNotesGateway.getProjectNotesList(noteID = 1) />
			<cfloop query="getProjectNotesList">
				<cfset assertTrue(getProjectNotesList.noteID eq 1, "Project notes were returned with the wrong ID.") />
			</cfloop>
	</cffunction>
	<cffunction name="D_getProjectNotesList_projectID" access="remote" returntype="void">
			<cfset ProjectNotesGateway = createObject("component", "components.project.ProjectNotesGateway") />
			<cfset getProjectNotesList = ProjectNotesGateway.getProjectNotesList(projectID = 1) />
			<cfloop query="getProjectNotesList">
				<cfset assertTrue(getProjectNotesList.projectID eq 1, "Project notes were returned from the wrong project.") />
			</cfloop>
	</cffunction>
	<cffunction name="D_getProjectNotesList_createdBy" access="remote" returntype="void">
			<cfset ProjectNotesGateway = createObject("component", "components.project.ProjectNotesGateway") />
			<cfset getProjectNotesList = ProjectNotesGateway.getProjectNotesList(createdBy = 1) />
			<cfloop query="getProjectNotesList">
				<cfset assertTrue(getProjectNotesList.createdBy eq 1, "Project notes were returned with the wrong creator.") />
			</cfloop>
	</cffunction>
	<cffunction name="D_getProjectNotesList_not_deleted" access="remote" returntype="void">
			<cfset ProjectNotesGateway = createObject("component", "components.project.ProjectNotesGateway") />
			<cfset getProjectNotesList = ProjectNotesGateway.getProjectNotesList(deleted = 0) />
			<cfloop query="getProjectNotesList">
				<cfset assertTrue(getProjectNotesList.deleted eq 0, "Projects were returned that are not deleted.") />
			</cfloop>
	</cffunction>
	<cffunction name="D_getProjectNotesList_deleted" access="remote" returntype="void">
			<cfset ProjectNotesGateway = createObject("component", "components.project.ProjectNotesGateway") />
			<cfset getProjectNotesList = ProjectNotesGateway.getProjectNotesList(deleted = 1) />
			<cfloop query="getProjectNotesList">
				<cfset assertTrue(getProjectNotesList.deleted eq 1, "Projects were returned that are not deleted.") />
			</cfloop>
	</cffunction>
	<cffunction name="G_getProjectNotesList_Returns_Zero_Records" access="remote" returntype="void">
			<cfset ProjectNotesGateway = createObject("component", "components.project.ProjectNotesGateway") />
			<cfset getProjectNotesList = ProjectNotesGateway.getProjectNotesList() />
			<cfset assertTrue(getProjectNotesList.recordCount eq 0, "No arguments were sent. Query should have returned 0 results.") />
	</cffunction>
	<cffunction name="H_getProjectNotesList_Returns_All_Records" access="remote" returntype="void">
			<cfset ProjectNotesGateway = createObject("component", "components.project.ProjectNotesGateway") />
			<cfset getProjectNotesList = ProjectNotesGateway.getProjectNotesList(all = 1) />
			<cfset assertTrue(getProjectNotesList.recordCount gt 0, "The 'all' argument was sent. Query should have returned results.") />
	</cffunction>
</cfcomponent>