<cfcomponent displayname="testProjects" extends="mxunit.framework.TestCase">
	<!--- Use getters and setters to link gateways to service. --->
	
	<cfset projectServiceDemo = createObject("component","components.services.ProjectServiceDemo") /> 	   
	<cfset projectServiceDemo.setProjectGateway(createObject("component","components.project.projectGateway")) /> 	   
	<cfset projectServiceDemo.setProjectMemberGateway(createObject("component","components.project.projectMemberGateway")) /> 	   
	<cfset projectServiceDemo.setProjectNotesGateway(createObject("component","components.project.projectNotesGateway")) /> 	   
	<!--- Tests existence of function. --->
	<cffunction name="A_getProject_Exists" access="remote" returntype="void">
		<cfscript>
			assertTrue(isStruct(projectServiceDemo.getProject00()));
		</cfscript>  
	</cffunction>
	<!--- Tests that a query is returned. --->
	<cffunction name="B_getProject_Returns_Struct_Fails" access="remote" returntype="void">
		<cfscript>
			assertTrue(isStruct(projectServiceDemo.getProject01()));
		</cfscript>  
	</cffunction>
	<cffunction name="C_getProject_Returns_Struct_Passes" access="remote" returntype="void">
		<cfscript>
			assertTrue(isStruct(projectServiceDemo.getProject02()));
		</cfscript>
	</cffunction>
	<!--- Tests for calling certain functions. --->
	<cffunction name="D_getProject_has_Project_Query_Fails" access="remote" returntype="void">
			<cfset var getProject = projectServiceDemo.getProject02() />
			<cfset assertTrue(isQuery(getProject.project), "No project query was returned.") />
	</cffunction>
	<cffunction name="E_getProject_has_Project_Query_Passes" access="remote" returntype="void">
			<cfset var getProject = projectServiceDemo.getProject03() />
			<cfset assertTrue(isQuery(getProject.project), "No project query was returned.") />
	</cffunction>

	<cffunction name="F_getProject_has_Members_Query_Fails" access="remote" returntype="void">
			<cfset var getProject = projectServiceDemo.getProject03() />
			<cfset assertTrue(isQuery(getProject.members), "No project members query was returned.") />
	</cffunction>
	<cffunction name="G_getProject_has_Members_Query_Passes" access="remote" returntype="void">
			<cfset var getProject = projectServiceDemo.getProject04() />
			<cfset assertTrue(isQuery(getProject.members), "No project members query was returned.") />
	</cffunction>

	<cffunction name="H_getProject_has_Notes_Query_Fails" access="remote" returntype="void">
			<cfset var getProject = projectServiceDemo.getProject04() />
			<cfset assertTrue(isQuery(getProject.notes), "No project notes query was returned.") />
	</cffunction>
	<cffunction name="I_getProject_has_Notes_Query_Passes" access="remote" returntype="void">
			<cfset var getProject = projectServiceDemo.getProject05() />
			<cfset assertTrue(isQuery(getProject.notes), "No project notes query was returned.") />
	</cffunction>

<!--- Tests for getting back specific records. --->
	<cffunction name="J_getProject_has_good_Project_Query_Fails" access="remote" returntype="void">
			<cfset var getProject = projectServiceDemo.getProject05(projectID = 1) />
			<cfset assertTrue(isQuery(getProject.project), "No query was returned.") />
			<cfset assertTrue(getProject.project.recordCount gt 0, "Query was returned, but had no project data.") />
			<cfloop query="getProject.project">
				<cfset assertTrue(getProject.project.projectID eq 1, "Incorrect project was returned (projectID #getProject.project.projectID#).") />
			</cfloop>
	</cffunction>
	<cffunction name="K_getProject_has_good_Project_Query_Passes" access="remote" returntype="void">
			<cfset var getProject = projectServiceDemo.getProject06(projectID = 1) />
			<cfset assertTrue(isQuery(getProject.project), "No query was returned.") />
			<cfset assertTrue(getProject.project.recordCount gt 0, "Query was returned, but had no project data.") />
			<cfloop query="getProject.project">
				<cfset assertTrue(getProject.project.projectID eq 1, "Incorrect project was returned (projectID #getProject.project.projectID#).") />
			</cfloop>
	</cffunction>

<!--- Tests for getting back specific records. --->
	<cffunction name="L_getProject_has_good_Member_Query_Fails" access="remote" returntype="void">
			<cfset var getProject = projectServiceDemo.getProject06(projectID = 1) />
			<cfset assertTrue(isQuery(getProject.members), "No query was returned.") />
			<cfset assertTrue(getProject.members.recordCount gt 0, "Query was returned, but had no member data.") />
			<cfloop query="getProject.members">
				<cfset assertTrue(getProject.members.projectID eq 1, "Incorrect project was returned (projectID #getProject.members.projectID#).") />
			</cfloop>
	</cffunction>
	<cffunction name="M_getProject_has_good_Member_Query_Passes" access="remote" returntype="void">
			<cfset var getProject = projectServiceDemo.getProject07(projectID = 1) />
			<cfset assertTrue(isQuery(getProject.members), "No query was returned.") />
			<cfset assertTrue(getProject.members.recordCount gt 0, "Query was returned, but had no member data.") />
			<cfloop query="getProject.members">
				<cfset assertTrue(getProject.members.projectID eq 1, "Incorrect project was returned (projectID #getProject.members.projectID#).") />
			</cfloop>
	</cffunction>

<!--- Tests for getting back specific records. --->
	<cffunction name="N_getProject_has_good_Notes_Query_Fails" access="remote" returntype="void">
			<cfset var getProject = projectServiceDemo.getProject07(projectID = 1) />
			<cfset assertTrue(isQuery(getProject.notes), "No query was returned.") />
			<cfset assertTrue(getProject.notes.recordCount gt 0, "Query was returned, but had no note data.") />
			<cfloop query="getProject.notes">
				<cfset assertTrue(getProject.notes.projectID eq 1, "Incorrect project was returned (projectID #getProject.notes.projectID#).") />
			</cfloop>
	</cffunction>
	<cffunction name="O_getProject_has_good_Notes_Query_Passes" access="remote" returntype="void">
			<cfset var getProject = projectServiceDemo.getProject08(projectID = 1) />
			<cfset assertTrue(isQuery(getProject.notes), "No query was returned.") />
			<cfset assertTrue(getProject.notes.recordCount gt 0, "Query was returned, but had no note data.") />
			<cfloop query="getProject.notes">
				<cfset assertTrue(getProject.notes.projectID eq 1, "Incorrect project was returned (projectID #getProject.notes.projectID#).") />
			</cfloop>
	</cffunction>

</cfcomponent>
