<cfcomponent displayname="testUsers" extends="mxunit.framework.TestCase">
	<!--- Tests existence of function. --->
	<cffunction name="A_getUserList_Exists" access="remote" returntype="void">
		<cfscript>
			UserGateway = createObject("component", "components.user.userGateway");
			assertTrue(isQuery(UserGateway.getUserList()));
		</cfscript>  
	</cffunction>
	<!--- Tests that a query is returned. --->
	<cffunction name="B_getUserList_Returns_Query" access="remote" returntype="void">
		<cfscript>
			UserGateway = createObject("component", "components.user.userGateway");
			assertTrue(isQuery(UserGateway.getUserList()));
		</cfscript>  
	</cffunction>
	<!--- Tests for meeting specific retrieval criteria. --->
	<cffunction name="C_getUserList_userID" access="remote" returntype="void">
			<cfset UserGateway = createObject("component", "components.user.userGateway") />
			<cfset getUserList = UserGateway.getUserList(userID = 1) />
			<cfloop query="getUserList">
				<cfset assertTrue(getUserList.userID eq 1, "The wrong user was returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="D_getUserList_type_supervisor" access="remote" returntype="void">
			<cfset UserGateway = createObject("component", "components.user.userGateway") />
			<cfset getUserList = UserGateway.getUserList(type = 'S') />
			<cfloop query="getUserList">
				<cfset assertTrue(getUserList.type is 'S', "A user who is not a supervisor was returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="E_getUserList_type_developer" access="remote" returntype="void">
			<cfset UserGateway = createObject("component", "components.user.userGateway") />
			<cfset getUserList = UserGateway.getUserList(type = 'D') />
			<cfloop query="getUserList">
				<cfset assertTrue(getUserList.type is 'D', "A user who is not a developer was returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="F_getUserList_type_tester" access="remote" returntype="void">
			<cfset UserGateway = createObject("component", "components.user.userGateway") />
			<cfset getUserList = UserGateway.getUserList(type = 'T') />
			<cfloop query="getUserList">
				<cfset assertTrue(getUserList.type is 'T', "A user who is not a tester was returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="G_getUserList_type_user" access="remote" returntype="void">
			<cfset UserGateway = createObject("component", "components.user.userGateway") />
			<cfset getUserList = UserGateway.getUserList(type = 'U') />
			<cfloop query="getUserList">
				<cfset assertTrue(getUserList.type is 'U', "A user who is not a standard user was returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="H_getUserList_email" access="remote" returntype="void">
			<cfset UserGateway = createObject("component", "components.user.userGateway") />
			<cfset getUserList = UserGateway.getUserList(email = 'test@test.com') />
			<cfloop query="getUserList">
				<cfset assertTrue(getUserList.email is 'test@test.com', "A user with the wrong email was returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="I_getUserList_Returns_Zero_Records" access="remote" returntype="void">
			<cfset UserGateway = createObject("component", "components.user.userGateway") />
			<cfset getUserList = UserGateway.getUserList() />
			<cfset assertTrue(getUserList.recordCount eq 0, "No arguments were sent. Query should have returned 0 results.") />
	</cffunction>
	<cffunction name="J_getUserList_Returns_All_Records" access="remote" returntype="void">
			<cfset UserGateway = createObject("component", "components.user.userGateway") />
			<cfset getUserList = UserGateway.getUserList(all = 1) />
			<cfset assertTrue(getUserList.recordCount gt 0, "The 'all' argument was sent. Query should have returned results.") />
	</cffunction>
</cfcomponent>