<cfcomponent displayname="testUserTypess" extends="mxunit.framework.TestCase">
	<!--- Tests existence of function. --->
	<cffunction name="A_getUserTypeList_Exists" access="remote" returntype="void">
		<cfscript>
			userTypeGateway = createObject("component", "components.user.userTypeGateway");
			assertTrue(isQuery(userTypeGateway.getUserTypeList()));
		</cfscript>  
	</cffunction>
	<!--- Tests that a query is returned. --->
	<cffunction name="B_getUserTypeList_Returns_Query" access="remote" returntype="void">
		<cfscript>
			userTypeGateway = createObject("component", "components.user.userTypeGateway");
			assertTrue(isQuery(userTypeGateway.getUserTypeList()));
		</cfscript>  
	</cffunction>
	<!--- Tests for meeting specific retrieval criteria. --->
	<cffunction name="C_getUserTypeList_typeID" access="remote" returntype="void">
			<cfset userTypeGateway = createObject("component", "components.user.userTypeGateway") />
			<cfset getUserTypeList = userTypeGateway.getUserTypeList(typeID = 1) />
			<cfloop query="getUserTypeList">
				<cfset assertTrue(getUserTypeList.typeID eq 1, "The wrong user type was returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="D_getUserTypeList_type_supervisor" access="remote" returntype="void">
			<cfset userTypeGateway = createObject("component", "components.user.userTypeGateway") />
			<cfset getUserTypeList = userTypeGateway.getUserTypeList(type = 'S') />
			<cfloop query="getUserTypeList">
				<cfset assertTrue(getUserTypeList.type is 'S', "A type that is not a supervisor was returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="E_getUserTypeList_type_developer" access="remote" returntype="void">
			<cfset userTypeGateway = createObject("component", "components.user.userTypeGateway") />
			<cfset getUserTypeList = userTypeGateway.getUserTypeList(type = 'D') />
			<cfloop query="getUserTypeList">
				<cfset assertTrue(getUserTypeList.type is 'D', "A type that is not a developer was returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="F_getUserTypeList_type_tester" access="remote" returntype="void">
			<cfset userTypeGateway = createObject("component", "components.user.userTypeGateway") />
			<cfset getUserTypeList = userTypeGateway.getUserTypeList(type = 'T') />
			<cfloop query="getUserTypeList">
				<cfset assertTrue(getUserTypeList.type is 'T', "A type that is not a tester was returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="G_getUserTypeList_type_user" access="remote" returntype="void">
			<cfset userTypeGateway = createObject("component", "components.user.userTypeGateway") />
			<cfset getUserTypeList = userTypeGateway.getUserTypeList(type = 'U') />
			<cfloop query="getUserTypeList">
				<cfset assertTrue(getUserTypeList.type is 'U', "A type that is not a standard user was returned.") />
			</cfloop>
	</cffunction>
	<cffunction name="I_getUserTypeList_Returns_Zero_Records" access="remote" returntype="void">
			<cfset userTypeGateway = createObject("component", "components.user.userTypeGateway") />
			<cfset getUserTypeList = userTypeGateway.getUserTypeList() />
			<cfset assertTrue(getUserTypeList.recordCount eq 0, "No arguments were sent. Query should have returned 0 results.") />
	</cffunction>
	<cffunction name="J_getUserTypeList_Returns_All_Records" access="remote" returntype="void">
			<cfset userTypeGateway = createObject("component", "components.user.userTypeGateway") />
			<cfset getUserTypeList = userTypeGateway.getUserTypeList(all = 1) />
			<cfset assertTrue(getUserTypeList.recordCount gt 0, "The 'all' argument was sent. Query should have returned results.") />
	</cffunction>
</cfcomponent>